'==============================================================
'	ANALOGUE LED CLOCK v2.1 N&V
'	PIC 16F877 @ 20MHz 
'	By D.J.Welburn July 2010 
'	djwprojects@live.co.uk  
'	www.youtube.com/user/wellyb00t
'	http://twitter.com/wellyb00t
'
'	Updated 17 May 2011 - Less flicker - Pattern demos
'	Power up & hourly short demo sequence
'	* * TIME SETTING IN DIGITAL MODE * * * 
'	Mode switching between analogue/digital & analogue only
'	by pressing '+' key whilst time is displayed
'
'	169 x 3mm white 700mcd leds 
'	PicBasicPro 2.46 - MPlab 8.15A
'		
'==============================================================	 

eeprom 0,[23,1,3,5,7,9,11,13,15,17,19,21,23]
eeprom 13,[23,23,0,0,0,1,1,2,2,2,3,3,4,4,4,5,5,6,6,6,7,7,8,8,8,9,9,10,10,10,11]
eeprom 44,[11,12,12,12,13,13,14,14,14,15,15,16,16,16,17,17,18,18,18,19]
eeprom 64,[19,20,20,20,21,21,22,22,22]
eeprom 73,[%00011111,%00010001,%00011111]	'0
eeprom 76,[%00000000,%00011111,%00000000,%00011101,%00010101,%00010111]
eeprom 82,[%00010101,%00010101,%00011111,%00000111,%00000100,%00011111]
eeprom 88,[%00010111,%00010101,%00011101,%00011111,%00010101,%00011100]	'5/6
eeprom 94,[%00000001,%00000001,%00011111,%00011111,%00010101,%00011111]
eeprom 100,[%00010111,%00010101,%00011111]


@	__config 0x3F76	'HS xtal
DEFINE OSC 20

TRISA = %00010110		'RA5 - B11 Output
TRISB = 0			'B0-7 outputs ULN2003 I/P
TRISD = 0			'White outputs RD0 = OUTER RING
TRISC = 0			'Green outputs RC0 = OUTER RING
TRISE = 0			'B8,9,10 Outputs to ULN2003 I/p
'-------------------------------------------------------------------------------------------------
'----------------------------I2C Bus SETUP for DS1307---------------------------------------------
'-------------------------------------------------------------------------------------------------
' RTC DS1307	clock - pin 6
'		Data - pin 5

cont		var	byte : addr		var	byte 
ICD	var	PORTA.3	: ICC	var	PORTA.4	'I2C Data/Clock
RTCsec		var	byte : RTCmin		var	byte : RTChour	var	byte
hour	var	byte : minu	var	byte 
	
'-------------------------------------------------------------------------------------------------
'----------------------------Buttons Setup--------------------------------------------------------
'-------------------------------------------------------------------------------------------------
SYMBOL set = PORTA.2	'Set button
SYMBOL move = PORTA.1	'+ Button
'-------------------------------------------------------------------------------------------------
'----------------------------Varibles ------------------------------------------------------------
'-------------------------------------------------------------------------------------------------

hourhand	var byte 	'LED Hour Hand 
minhand		var	byte	'LED mins Hand 
digitA		var	byte
digitB		var	byte
digitD		var	byte
digitC		var	byte
ledtime		var	byte [12]	

minuchange	var	byte	'For checking if mins as changed 
setup	var	byte		'setup flag 1=mins 2=hours setup 0=not setting up
skipdim	var	bit		'1= show dimmer leds on outer circle	
rowA	VAR	BYTE [24]	'LED DATA ARRAY
scancol	VAR	BYTE		'For scaning led array 
scan	VAR	WORD		'for scanning led array
counter	var	word		'General purpose counter WORD
counterB	var	byte	'as above
counterC	var	byte	'As above
pivot	var	bit		'pivot led
timedelay	var	word	'demo speed
rtcbit	var	byte		'Counter for DS1307 read
digiton	var	bit		'1 = Analogue/digital mode on, 0 = analogue only

CLEAR				'Clear all varibles to 0
cont = %11010000		'I2C control $D0
ADCON1 = %00000111		'all port A digital i/o
digiton = 1
'----------------------------------------------------------------------------------
'----------------------- Set Up timer interupts------------------------------------
'----------------------------------------------------------------------------------
OPTION_REG = %00000110	'1:128 prescale 
ON INTERRUPT GOTO display
INTCON = %10100000
'==================================================================================
'----------------------- Start up LED display demo & hourly demo-------------------
'==================================================================================
MAIN:
skipdim = 0
FOR counterB = 0 TO 23
	rowA [counterB-1] = 0	'*
	rowA [counterB] = %11111111
	FOR counter = 0 TO 1500
		PAUSEUS 5
	NEXT counter
NEXT counterB
	rowA [23] = 0
'---------------------------------segment demo------------------------------------
FOR counter = 0 TO 23
	rowA [counter] = 0
NEXT counter
	timedelay = 5000
	rowA [0] = %11111111
	rowA [1] = %11111111
	rowA [2] = %11111111
	rowA [6] = %11111111
	rowA [7] = %11111111
	rowA [8] = %11111111
	rowA [12] = %11111111
	rowA [13] = %11111111
	rowA [14] = %11111111
	rowA [18] = %11111111
	rowA [19] = %11111111
	rowA [20] = %11111111
	FOR counterC = 0 TO 5
		FOR counter = 0 TO timedelay
			PAUSEUS 5
		NEXT counter
		FOR counterB = 0 TO 23
			rowA [counterB] = rowA [counterB] ^ $FF
		NEXT counterB
		timedelay = timedelay - 100
	NEXT counterC
	FOR counterC = 0 TO 15
		FOR counter = 0 TO timedelay
			PAUSEUS 5
		NEXT counter
		FOR counterB = 0 TO 23
			rowA [counterB] = rowA [counterB] ^ $FF
		NEXT counterB
	NEXT counterC
'----------------------Explosion demo 1-------------------------------------
rowA.0(95) = 1
	FOR counter = 0 TO 3500
		PAUSEUS 5
	NEXT counter
rowA.0(95) = 0
FOR counterB = 0 TO 23
	rowA [counterB] = %01000000
NEXT counterB
	FOR counter = 0 TO 3500
		PAUSEUS 5
	NEXT counter
FOR counterB = 0 TO 23
	rowA [counterB] = %00100000
NEXT counterB
	FOR counter = 0 TO 3500
		PAUSEUS 5
	NEXT counter
FOR counterB = 0 TO 23
	rowA [counterB] = %00010000
NEXT counterB
	FOR counter = 0 TO 3500
		PAUSEUS 5
	NEXT counter
FOR counterB = 0 TO 23
	rowA [counterB] = %00001000
NEXT counterB
	FOR counter = 0 TO 3500
		PAUSEUS 5
	NEXT counter
FOR counterB = 0 TO 23
	rowA [counterB] = %00000100
NEXT counterB
	FOR counter = 0 TO 3500
		PAUSEUS 5
	NEXT counter
FOR counterB = 0 TO 23
	rowA [counterB] = %00000010
NEXT counterB
	FOR counter = 0 TO 3500
		PAUSEUS 5
	NEXT counter
FOR counterB = 0 TO 23
	rowA [counterB] = %00000001
NEXT counterB
	FOR counter = 0 TO 3500
		PAUSEUS 5
	NEXT counter
FOR counterB = 0 TO 23
	rowA [counterB] = %00000000
NEXT counterB
	FOR counter = 0 TO 3500
		PAUSEUS 5
	NEXT counter
demo:'--------------------------------DJW Demo--------------------------------
rowA [11] = %11110000
FOR counterB = 0 TO 10
	rowA [counterB] = %00010000
NEXT counterB
rowA [23] = %11110000
FOR counter = 0 TO 12000
	PAUSEUS 5
NEXT counter
FOR counterB = 0 TO 23
	rowA [counterB] = 0
NEXT counterB
rowA [5] = %11110000
rowA [17] = %11110000
rowA [11] = %11111110
rowA [12] = %00000010
rowA [13] = %00000010
rowA [14] = %00000010
FOR counter = 0 TO 12000
	PAUSEUS 5
NEXT counter
FOR counterB = 0 TO 23
	rowA [counterB] = 0
NEXT counterB
FOR counterB = 5 TO 8
	rowA [counterB] = %00000001
NEXT counterB
rowA [9] = %01111111
rowA [13] = %01111111
FOR counterB = 14 TO 17
	rowA [counterB] = %00000001
NEXT counterB
FOR counter = 0 TO 10000
	PAUSEUS 5
NEXT counter
FOR counterB = 0 TO 23
	rowA [counterB] = 0
	FOR counter = 0 TO 500
		PAUSEUS 5
	NEXT counter
NEXT counterB

	'------------------------------- wheel demo ------------------
timedelay = 4000
rowA.0(95) = 0
FOR counterB = 0 TO 23
	rowA [counterB] = %00100001
NEXT counterB
rowA [1] = %00111111
rowA [7] = %00111111
rowA [13] = %00111111
rowA [19] = %00111111
FOR counterC = 0 TO 23
	FOR counter = 0 TO timedelay
		PAUSEUS 5
	NEXT counter
	FOR counterB = 0 TO 22
		rowA [counterB] = rowA [counterB+1]
	NEXT counterB
	rowA [23] = rowA [0]
	timedelay = timedelay - 80
NEXT counterC
FOR counterC = 0 TO 40
	FOR counter = 0 TO timedelay
		PAUSEUS 5
	NEXT counter
	rowA [23] = rowA [0]
	FOR counterB = 0 TO 22
		rowA [counterB] = rowA [counterB+1]
	NEXT counterB
NEXT counterC
demo1:	'----------------------------- implosion demo ----------------
timedelay = 3500
FOR counterB = 0 TO 23
	rowA [counterB] = %00000001
NEXT counterB
	FOR counter = 0 TO timedelay
		PAUSEUS 5
	NEXT counter
FOR counterB = 0 TO 23
	rowA [counterB] = %00000010
NEXT counterB
	FOR counter = 0 TO timedelay
		PAUSEUS 5
	NEXT counter
FOR counterB = 0 TO 23
	rowA [counterB] = %00000100
NEXT counterB
	FOR counter = 0 TO timedelay
		PAUSEUS 5
	NEXT counter
FOR counterB = 0 TO 23
	rowA [counterB] = %00001000
NEXT counterB
	FOR counter = 0 TO timedelay
		PAUSEUS 5
	NEXT counter
FOR counterB = 0 TO 23
	rowA [counterB] = %00010000
NEXT counterB
	FOR counter = 0 TO timedelay
		PAUSEUS 5
	NEXT counter
FOR counterB = 0 TO 23
	rowA [counterB] = %00100000
NEXT counterB
	FOR counter = 0 TO timedelay
		PAUSEUS 5
	NEXT counter
FOR counterB = 0 TO 23
	rowA [counterB] = %01000000
NEXT counterB
	FOR counter = 0 TO timedelay
		PAUSEUS 5
	NEXT counter
FOR counterB = 0 TO 23
	rowA [counterB] = %00000000
NEXT counterB
rowA.0(95) = 1
	FOR counter = 0 TO timedelay
		PAUSEUS 5
	NEXT counter
'----------------------explosion demo 2-------------------------------------
rowA.0(95) = 1
	FOR counter = 0 TO 3500
		PAUSEUS 5
	NEXT counter
rowA.0(95) = 0
FOR counterB = 1 TO 23 STEP 2
	rowA [counterB] = %01000000
NEXT counterB
	FOR counter = 0 TO 3500
		PAUSEUS 5
	NEXT counter
FOR counterB = 1 TO 23 STEP 2
	rowA [counterB] = %00100000
NEXT counterB
	FOR counter = 0 TO 3500
		PAUSEUS 5
	NEXT counter
FOR counterB = 1 TO 23 STEP 2
	rowA [counterB] = %00010000
NEXT counterB
	FOR counter = 0 TO 3500
		PAUSEUS 5
	NEXT counter
FOR counterB = 1 TO 23 STEP 2
	rowA [counterB] = %00001000
NEXT counterB
	FOR counter = 0 TO 3500
		PAUSEUS 5
	NEXT counter
FOR counterB = 1 TO 23 STEP 2
	rowA [counterB] = %00000100
NEXT counterB
	FOR counter = 0 TO 3500
		PAUSEUS 5
	NEXT counter
FOR counterB = 1 TO 23 STEP 2
	rowA [counterB] = %00000010
NEXT counterB
	FOR counter = 0 TO 3500
		PAUSEUS 5
	NEXT counter
FOR counterB = 1 TO 23 STEP 2
	rowA [counterB] = %00000001
NEXT counterB
	FOR counter = 0 TO 3500
		PAUSEUS 5
	NEXT counter
minuchange = 61
skipdim = 1
'***************************************************************************************************
'======================================== Main Loop ================================================
'***************************************************************************************************
loop:
'===============================================================================================
'=================================== Mode setting ==============================================
'===============================================================================================
	IF move = 0 THEN
		digiton = digiton + 1
		timedelay = 2500
		GOTO demo1
	ENDIF	

'==================================================================================================
'============================= UPDATING HAND POSITION =============================================
'==================================================================================================						
	IF minu <> minuchange THEN	
		GOSUB read_digit
		skipdim = 1
		pivot = 1
		FOR counter = 0 TO 23
			rowA [counter] = 0
		NEXT
		READ hour, hourhand
		IF minu > 31 THEN
			IF hourhand = 23 THEN
				hourhand = 0
			ELSE
				hourhand = hourhand + 1
			ENDIF
		ENDIF
		rowA [hourhand] = %01111000
		READ minu+13, minhand
		rowA [minhand] = %01111111
		IF minhand = hourhand THEN		'If both min and hour on same hand, 3 led goes out
			rowA [minhand] = rowA [minhand] - 4
		ENDIF
		minuchange = minu
	ENDIF
'===============================================================================================
'=============================== Dgital Mode display ===========================================
'===============================================================================================	
	IF digiton = 1 THEN				'<--------Digital mode on routine
		IF RTCsec = $02 AND minu = 0 THEN	'<--------Starts Hourly Demo		
			GOTO main				
		ENDIF
		IF RTCsec = $39 THEN		'<------Clears Display at 39 seconds
			pivot = 0			
			rowA [hourhand] = 0
			rowA [minhand] = 0		
		ENDIF
		IF RTCsec = $40 THEN		'<----- DIGITAL READOUT AT 40 SECONDS
			skipdim = 0	
			GOSUB digit_on	
		ENDIF
		IF RTCsec = $55 THEN		'<------Display implosion demo at 55 seconds then display hands
			GOTO demo1
		ENDIF
	ENDIF

'===============================================================================================
'===================================Time Setting================================================
'===============================================================================================
setloop:
	rowA.0(95) = pivot 	'centre led
	IF set = 0 THEN
		IF setup = 0 THEN	'-------clears display-------
			FOR counter = 0 TO 23
				rowA [counter] = 0
			NEXT counter
		ENDIF
		setup = setup + 1 			
		IF setup > 2 THEN
			INTCON.7 = 0 	'disable interupts
			RTCmin = minu DIG 1 		'-----------------------
			RTCmin = RTCmin << 4 		' Covert decimal to BCD |     
			RTCmin = RTCmin + minu DIG 0
			RTChour = hour DIG 1		
			RTChour = RTChour << 4 		 
			RTChour = RTChour + hour DIG 0 	'-----------------------
			RTChour.6 = 1		'Set Ds1307 into 12hr mode
			I2CWrite ICD, ICC, cont, addr, [0, RTCmin, RTChour,1,1,1,1,0]	'Write data in BCD to DS1307
			PAUSE 20	
			INTCON.7 = 1	'enable interupts
			setup = 0
			GOTO demo1
		ENDIF
		FOR counter = 0 TO 6000
			PAUSEUS 5
		NEXT counter	
	ENDIF
	IF move = 0 AND setup = 1 THEN
		minu = minu + 1
		IF minu > 59 THEN
			minu = 0
		ENDIF
		FOR counter = 0 TO 5000
			PAUSEUS 5
		NEXT counter	
	ENDIF
	IF move = 0 AND setup = 2 THEN
		hour = hour + 1
		FOR counterB = 0 TO 23
			rowA [counterB] = 0
		NEXT counterB
		IF hour > 12 THEN
			hour = 1
		ENDIF
		FOR counter = 0 TO 5000
			PAUSEUS 5
		NEXT counter	
	ENDIF
	IF setup <> 0 THEN
		pivot = 0
		GOSUB read_digit
		GOSUB digit_on
		GOTO setloop
	ENDIF
GOTO loop
'
'*******************************************************************************************
'
Read_digit:	'-----------------------Reads digit data into ledtime-----------------
	digitA = hour DIG 1
	digitB = hour DIG 0
	digitC = minu DIG 1
	digitD = minu DIG 0
	FOR counter = 73 TO 75
		READ digitA*3+counter,ledtime [counter-73]		
		READ digitB*3+counter,ledtime [counter-70]	
		READ digitC*3+counter,ledtime [counter-67]	
		READ digitD*3+counter,ledtime [counter-64]	
	NEXT counter
RETURN

Digit_on:	'-----------------------displays digit data into led array-------------
	IF hour < 10 THEN
		FOR counter = 0 TO 2 	
			rowA [17+counter] = ledtime [counter+3]
			rowA [3+counter] = ledtime [counter+9]
		NEXT counter
		rowA [23] = ledtime [6]
		rowA [0] = ledtime [7]
		rowA [1] = ledtime [8]
		rowA [21] = %00001010
	ELSE
		FOR counter = 0 TO 2
			rowA [15+counter] = ledtime [counter] 	
			rowA [19+counter] = ledtime [counter+3]
			rowA [1+counter] = ledtime [counter+6]
			rowA [5+counter] = ledtime [counter+9]
		NEXT counter
		rowA [23] = %00001010
	ENDIF	
RETURN


'============================================================================================
'===================================Display update routine===================================
'============================================================================================
DISABLE
display:
	rtcbit = rtcbit + 1
	IF skipdim = 1 THEN
		PORTB = %10101010
		PORTA.5 = 1
		PORTE.1 = 1
		PORTC = %00000001
		PORTD = %00000001
		PAUSEUS 70
		PORTC = 0
		PORTD = 0
	ENDIF
	IF setup = 0 AND rtcbit = 40 THEN						'Reads DS1307 every 40 interupts 
		rtcbit = 0
		I2CRead ICD, ICC, cont, addr, [RTCsec, RTCmin, RTChour]			'Reads Ds1307 via I2c bus
		RTCHour.6 = 0: RTChour.5 = 0						'Clears 12hr mode & AM/PM marker bits
		hour = RTChour >> 4:hour = hour * 10:RTChour = RTChour &$0F: hour = hour + RTChour 	'Convert BCD to decimal for hours (&$0F clears upper 4bits)
		minu = RTCmin >> 4:minu = minu * 10: RTCmin = RTCmin &$0F: minu = minu + RTCmin 	'Convert BCD to decimal for mins
	ENDIF
	scan = 1
	FOR scancol = 0 TO 11
		PORTB = scan.lowbyte		'PIN 33 = B0 & PIN 40 = B7
		PORTE.2 = scan.8 			'Pin 10 - B8
		PORTE.1 = scan.9 			'Pin 9  - B9
		PORTE.0 = scan.10  			'Pin 8  - B10
		PORTA.5 = scan.11  			'Pin 7  - B11	
		PORTC = rowA [scancol]		'Green Outputs
		PORTD = rowA [scancol+12]	'White Outputs
		PAUSEUS 500 
		PORTC = 0
		PORTD = 0
		scan = scan * 2 	
	NEXT scancol
	scan = 0
	INTCON.2 = 0
	RESUME
	ENABLE
END
